<?php
/**
 * @package	HikaShop for Joomla!
 * @version	2.6.1
 * @author	hikashop.com
 * @copyright	(C) 2010-2015 HIKARI SOFTWARE. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgHikashopContest_winners extends JPlugin{
	function plgHikashopContest_winners(&$subject, $config){
		parent::__construct($subject, $config);
	}

	function onHikashopCronTrigger(&$messages){
		if(hikashop_level(1)){
			$pluginsClass = hikashop_get('class.plugins');
			$plugin = $pluginsClass->getByName('hikashop','contest_winners');

			if(empty($plugin->params['frequency'])){
				$plugin->params['frequency'] = 3600;
			}
			if(!empty($plugin->params['last_cron_update']) && $plugin->params['last_cron_update']+$plugin->params['frequency']>time()){
				return true;
			}

			if(date('n') !== $plugin->params['day_of_month'] && date('G') !== $plugin->params['hour_of_day']){
				return true;
			}

			$plugin->params['last_cron_update']=time();
			$pluginsClass->save($plugin);
			$pluginsClass->loadParams($plugin);
			$winner = pickWinner();

			$app = JFactory::getApplication();
			if(!empty($winner)){
				$message = $winner.' was the winner for last month.';
			}else{
				$message = 'No winner was chosen for last month';
			}
			$messages[] = $message;
			$app->enqueueMessage($message);
		}
	}
	
	function pickWinner(){
		$cur_month_int = date('n');
		$last_month_int = DateTime::createFromFormat('n', $cur_month_int-1);
		$last_month_text = $last_month_int->format('F');
		//get database connection
		$db = JFactory::getDbo();
		//create query object
		$query = $db->getQuery(true);
		$query
			->select('*')
			->from($db->quoteName('#__contest_entries'))
			->where($db->quoteName('month').' LIKE \''.$last_month_text.'\'');
		$db->setQuery($query);
		$entries = $db->loadObjectList();
		//create array to store ids
		$ids = array();
		foreach($entries as $entry){
			$ids[]= $entry->id;
		}
		//find min id for selected month
		$min_id = min($ids);
		//find max id for selected month
		$max_id = max($ids);
		//pick random id for winner
		$random_id = mt_rand($min_id,$max_id);
		//update winner in table
		$update = $db->getQuery(true);
		$update
			->update($db->quoteName('#__contest_entries'))
			->set($db->quoteName('winner') . ' = Yes')
			->where($db->quoteName('id').' = '.$random_id);
		$db->setQuery($update);
		$result = $db->execute();
		//select winner from table
		$winner_query = $db->getQuery(true);
		$winner_query
			->select('*')
			->from($db->quoteName('#__contest_entries'))
			->where($db->quoteName('month').' LIKE \''.$last_month_text.'\' AND '.$db->quoteName('winner').' LIKE \'Yes\'');
		$db->setQuery($winner_query);
		$row = $db->loadObject();
		$winner = $row->name;
		return $winner;
	}
}